// Code generated by github.com/99designs/gqlgen, DO NOT EDIT.

package model

import (
	"fmt"
	"io"
	"strconv"
)

type NewNode struct {
	Name        string     `json:"name"`
	Tags        []*string  `json:"tags"`
	Access      NodeAccess `json:"access"`
	Nsfw        bool       `json:"nsfw"`
	Description *string    `json:"description"`
}

type NewPost struct {
	Type     PostType `json:"type"`
	Title    string   `json:"title"`
	Link     *string  `json:"link"`
	Delta    *string  `json:"delta"`
	NodeName string   `json:"nodeName"`
}

type NewUser struct {
	Name *string `json:"name"`
}

type Node struct {
	Name        string     `json:"name"`
	Tags        []*string  `json:"tags"`
	Access      NodeAccess `json:"access"`
	Nsfw        bool       `json:"nsfw"`
	Description *string    `json:"description"`
}

type Post struct {
	ID       string  `json:"id"`
	Title    string  `json:"title"`
	Link     *string `json:"link"`
	Delta    *string `json:"delta"`
	NodeName string  `json:"nodeName"`
}

type User struct {
	Name  string `json:"name"`
	Bases int    `json:"bases"`
}

type NodeAccess string

const (
	NodeAccessPublic     NodeAccess = "public"
	NodeAccessRestricted NodeAccess = "restricted"
	NodeAccessPrivate    NodeAccess = "private"
)

var AllNodeAccess = []NodeAccess{
	NodeAccessPublic,
	NodeAccessRestricted,
	NodeAccessPrivate,
}

func (e NodeAccess) IsValid() bool {
	switch e {
	case NodeAccessPublic, NodeAccessRestricted, NodeAccessPrivate:
		return true
	}
	return false
}

func (e NodeAccess) String() string {
	return string(e)
}

func (e *NodeAccess) UnmarshalGQL(v interface{}) error {
	str, ok := v.(string)
	if !ok {
		return fmt.Errorf("enums must be strings")
	}

	*e = NodeAccess(str)
	if !e.IsValid() {
		return fmt.Errorf("%s is not a valid NodeAccess", str)
	}
	return nil
}

func (e NodeAccess) MarshalGQL(w io.Writer) {
	fmt.Fprint(w, strconv.Quote(e.String()))
}

type PostType string

const (
	PostTypeText  PostType = "text"
	PostTypeMedia PostType = "media"
	PostTypeLink  PostType = "link"
)

var AllPostType = []PostType{
	PostTypeText,
	PostTypeMedia,
	PostTypeLink,
}

func (e PostType) IsValid() bool {
	switch e {
	case PostTypeText, PostTypeMedia, PostTypeLink:
		return true
	}
	return false
}

func (e PostType) String() string {
	return string(e)
}

func (e *PostType) UnmarshalGQL(v interface{}) error {
	str, ok := v.(string)
	if !ok {
		return fmt.Errorf("enums must be strings")
	}

	*e = PostType(str)
	if !e.IsValid() {
		return fmt.Errorf("%s is not a valid PostType", str)
	}
	return nil
}

func (e PostType) MarshalGQL(w io.Writer) {
	fmt.Fprint(w, strconv.Quote(e.String()))
}
